#!/bin/bash
#
# for old-fashioned builds (new scheme is more sensible to this respect)
#
# typical disk space
# total		: 4.5 G
# BUILD		: 3.2 G
# CODEBASES	: 400 M
# SOURCES	: 460 M
# we keep only RPMS and SPRMS

totrash="BUILD CODEBASES SOURCES tmp"

for build in "$@" ; do
    text_base=$(basename $build .log.txt)
    if [ "$text_base" != "$build" ] ; then
	echo "Removing txt link $build"
	rm "$build"
	continue
    fi
    base=$(basename $build)
    trashbase=/build/trash/$base
    [ -d $trashbase ] || mkdir $trashbase
    for dir in $totrash ; do
	if [ -d $build/build/$dir ] ; then
	    echo "Trashing $build/build/$dir"
	    mv $build/build/$dir $trashbase/$dir
	fi
    done
done

